<?php

namespace FM\Controller;

use Zeedhi\Framework\DTO\Request;
use FM\Traits\TResponse;
use FM\Service\Fm00040000ModeloAuditoriaService;

class Fm00040000ModeloAuditoriaController
{
    protected $ModeloAuditoriaService;

    use TResponse;

    public function __construct(Fm00040000ModeloAuditoriaService $ModeloAuditoriaService)
    {
        $this->ModeloAuditoriaService = $ModeloAuditoriaService;
    }

    public function getTarefasAuditoria()
    {
        try {
            $data = $this->ModeloAuditoriaService->getTarefasAuditoria();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function inserirTarefaAuditoria(Request $request)
    {
        try {
            $data = $this->ModeloAuditoriaService->inserirTarefaAuditoria($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    // Funções da Tab Modelo
    public function getEstruturaModelo(Request $request)
    {
        try {
            $data = $this->ModeloAuditoriaService->getEstruturaModelo($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function salvarModelo(Request $request)
    {
        try {
            $data = $this->ModeloAuditoriaService->salvarModelo($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function salvarModeloAuditoria(Request $request)
    {
        try {
            $this->ModeloAuditoriaService->salvarModeloAuditoria($request->getParameters());
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
    
    public function getModeloAuditoria()
    {
        try {
            $data = $this->ModeloAuditoriaService->getModeloAuditoria();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
    
    /* Funções da tab de Categoria */
    public function salvarCategoriaAuditoria(Request $request)
    {
        try {
            $this->ModeloAuditoriaService->salvarCategoriaAuditoria($request->getParameters());
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
    
    public function getCategoriaAuditoria()
    {
        try {
            $data = $this->ModeloAuditoriaService->getCategoriaAuditoria();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function excluirCategoria(Request $request)
    {
        try {
            $data = $this->ModeloAuditoriaService->excluirCategoria($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    //Funções tab Tópicos
    public function salvarTopicosAuditoria(Request $request)
    {
        try {
            $this->ModeloAuditoriaService->salvarTopicosAuditoria($request->getParameters());
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
    
    public function getTopicosAuditoria()
    {
        try {
            $data = $this->ModeloAuditoriaService->getTopicosAuditoria();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function excluirTopicos(Request $request)
    {
        try {
            $data = $this->ModeloAuditoriaService->excluirTopicos($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    // Funções da TAB de Critérios
    public function salvarCriteriosAvaliacao(Request $request)
    {
        try {
            $this->ModeloAuditoriaService->salvarCriteriosAvaliacao($request->getParameters());
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
    
    public function getCriteriosAvaliacao()
    {
        try {
            $data = $this->ModeloAuditoriaService->getCriteriosAvaliacao();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function excluirRegistros(Request $request)
    {
        try {
            $data = $this->ModeloAuditoriaService->excluirRegistros($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
