<?php

namespace FM\Service;

use FM\Factory\FindFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use FM\Service\FuncionariosHierarqService;

class FindService
{

    protected $FindFactory;
    protected $Environment;
    protected $newCode;
    protected $FuncionariosHierarqService;

    public function __construct(FindFactory $FindFactory, Environment $Environment, NewCode $newCode, FuncionariosHierarqService $FuncionariosHierarqService)
    {
        $this->FindFactory                  = $FindFactory;
        $this->Environment                  = $Environment;
        $this->newCode                      = $newCode;
        $this->FuncionariosHierarqService   = $FuncionariosHierarqService;
    }

    public function findOperador($filtro)
    {
        $where = $this->montarFiltro($filtro);
        return $this->FindFactory->findOperador($where);
    }

    public function findTipoSolicitacao($filtro)
    {
        $where = $this->montarFiltro($filtro);
        return $this->FindFactory->findTipoSolicitacao($filtro);
    }

    public function findOperadorHierarq($filtro)
    {
        $where = $this->montarFiltro($filtro);
        $listaLocais = $this->FuncionariosHierarqService->getLocaisHierarquia($this->Environment->getCdOperador());
        return $this->FindFactory->findOperadorHierarq($where, $listaLocais);
    }

    public function findLocal($filtro)
    {
        $where = $this->montarFiltro($filtro);
        $listaLocais = $this->FuncionariosHierarqService->getLocaisHierarquia($this->Environment->getCdOperador());
        return $this->FindFactory->findLocal($where, $listaLocais);
    }

    public function findTipoLocal($filtro)
    {
        $where = $this->montarFiltro($filtro);
        return $this->FindFactory->findTipoLocal($where);
    }

    public function findChecklist($filtro)
    {
        $where = $this->montarFiltro($filtro);
        return $this->FindFactory->findChecklist($where);
    }

    public function findServico($filtro)
    {
        $where = $this->montarFiltro($filtro);
        return $this->FindFactory->findServico($where);
    }

    public function findTipoMedidaSm($filtro)
    {
        $where = $this->montarFiltro($filtro);
        return $this->FindFactory->findTipoMedidaSm($where);
    }

    public function findItens($filtro)
    {
        $where = $this->montarFiltro($filtro);
        return $this->FindFactory->findItens($where);
    }

    public function findEscoposServicos($filtro)
    {
        $where = $this->montarFiltro($filtro);
        return $this->FindFactory->findEscoposServicos($where);
    }

    public function findAtividades($filtro)
    {
        $where = $this->montarFiltro($filtro);
        return $this->FindFactory->findAtividades($where);
    }

    public function findItensChecklist($filtro)
    {
        $where = $this->montarFiltro($filtro);
        return $this->FindFactory->findItensChecklist($where);
    }

    public function findClientes($filtro)
    {
        $where = $this->montarFiltro($filtro);
        return $this->FindFactory->findClientes($where);
    }

    public function findPrioridades($filtro)
    {
        $where = $this->montarFiltro($filtro);
        return $this->FindFactory->findPrioridades($where);
    }

    public function formatarArray($array)
    {
        $arrayModificado = array();

        foreach ($array as $valor) {
            array_push($arrayModificado, "'" . $valor . "'");
        }

        return implode(',', $arrayModificado);
    }

    public function montarFiltro($find)
    {
        $operador = $this->Environment->getCdOperador();

        if (empty($find)) {
            return ' 1 = 1';
        }
        $whereClause = [];
        foreach ($find as $column => $condition) {
            $operator = key($condition);
            $value = $condition[$operator];

            if ($value === 'OPERADOR_LOGADO') {
                $value = $operador;
            }

            if (in_array($operator, ["IN", "NOT_IN"])) {
                $value = "($value)";
            } else {
                $value = "'$value'";
            }

            $whereClause[] = "$column $operator $value";
        }

        return " " . implode(" AND ", $whereClause);
    }
}
