<?php

namespace FM\Service;

use FM\Factory\Fm00011000AnaliseNaoConformidadesFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;
use FM\Service\FindService;
use Zeedhi\Framework\Util;

class Fm00011000AnaliseNaoConformidadesService
{

    protected $AnaliseNaoConformidadeFactory;
    protected $Environment;
    protected $newCode;
    protected $FindService;
    protected $connection;

    public function __construct(EntityManager $entityManager, Fm00011000AnaliseNaoConformidadesFactory $AnaliseNaoConformidadeFactory, FindService $FindService, Environment $Environment, NewCode $newCode)
    {
        $this->connection                     = $entityManager->getConnection();
        $this->AnaliseNaoConformidadeFactory  = $AnaliseNaoConformidadeFactory;
        $this->FindService                    = $FindService;
        $this->Environment                    = $Environment;
        $this->newCode                        = $newCode;
    }

    public function getNaoConformidadesGerais()
    {

        /* $filter = "";
        if (isset($params['NRLOCALCLIENTE'])) {
            $NR = $this->FindService->formatarArray($params['NRLOCALCLIENTE']);
            $filter .= "AND LOC.NRLOCALCLIENTE IN  ($NR) ";
        }
        if (isset($params['NRTIPOLOCALCLI'])) {
            $NR = $this->FindService->formatarArray($params['NRTIPOLOCALCLI']);
            $filter .= "AND LOC.NRTIPOLOCALCLI IN  ($NR) ";
        }
        if (isset($params['CDOPERADOR'])) {
            $NR = $this->FindService->formatarArray($params['CDOPERADOR']);
            $filter .= "AND OPER.CDOPERADOR IN  ($NR) ";
        }
        if (isset($params['CDOPERADORPAI'])) {
            $NR = $this->FindService->formatarArray($params['CDOPERADORPAI']);
            $filter .= "AND HC.CDOPERADORPAI IN  ($NR) ";
        }
        if (isset($params['filtroDataRange'])) {
            $dataInicial = $params['filtroDataRange'][0];
            $dataFinal =  property_exists("1", $params['filtroDataRange']) ? $params['filtroDataRange'][1] : null;

            if ($dataFinal != null) {
                $filter .= "AND GECHK.DTHORAAGEND BETWEEN '" . $dataInicial . "' AND '" . $dataFinal . "'";
            } else {
                $filter .= "AND GECHK.DTHORAAGEND BETWEEN '" . $dataInicial . "' AND '" . $dataInicial . "'";
            }
        } */

        return $this->AnaliseNaoConformidadeFactory->getNaoConformidadesGerais();
    }

    public function getPrincipaisNaoConformidades($params)
    {
        $filter = "";
        if (isset($params['filtroDataRange'])) {
            $dataInicial = $params['filtroDataRange'][0];
            $dataFinal = property_exists("1", $params['filtroDataRange']) ? $params['filtroDataRange'][1] : null;

            if ($dataFinal != null) {
                $filter .= "AND GECHK.DTHORAAGEND BETWEEN '" . $dataInicial . "' AND '" . $dataFinal . "'";
            } else {
                $filter .= "AND GECHK.DTHORAAGEND BETWEEN '" . $dataInicial . "' AND '" . $dataInicial . "'";
            }
        }
        return $this->AnaliseNaoConformidadeFactory->getPrincipaisNaoConformidades($filter);
    }

    public function getCriteriosNaoConformidades()
    {
        return $this->AnaliseNaoConformidadeFactory->getCriteriosNaoConformidades();
    }
}
