<?php

namespace FM\Service;

use FM\Factory\GerenciamentoChkFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;
use FM\Service\LogTransfergerchkService;

class GerenciamentoChkService
{

    protected $connection;
    protected $GerenciamentoChkFactory;
    protected $Environment;
    protected $newCode;
    protected $LogTransfergerchkService;

    public function __construct(EntityManager $entityManager, LogTransfergerchkService $LogTransfergerchkService, GerenciamentoChkFactory $GerenciamentoChkFactory, Environment $Environment, NewCode $newCode)
    {
        $this->connection = $entityManager->getConnection();
        $this->GerenciamentoChkFactory = $GerenciamentoChkFactory;
        $this->LogTransfergerchkService = $LogTransfergerchkService;
        $this->Environment = $Environment;
        $this->newCode = $newCode;
    }

    public function listInspectionTask($param)
    {
        $params = "";
        if ($param["uni"] != "null") {
            $params .= " AND FCM_LOCALCLI.NRLOCALCLIENTEPAI in (SELECT FCM_LOCALCLI.NRLOCALCLIENTE FROM FCM_LOCALCLI
            WHERE FCM_LOCALCLI.NRLOCALCLIENTEPAI = " . $param["uni"] . ")";
        }
        if ($param["loc"] != "null") {
            $params .= " AND FCM_CHECKLISTAGEND.NRLOCALCLIENTE = " . $param["loc"];
        }
        if ($param["sec"] != "null") {
            $params .= " AND FCM_LOCALCLI.NRSETOR = " . $param["sec"];
        }
        if ($param["lct"] != "null") {
            $params .= " AND FCM_CHECKLISTAGEND.NRCHECKLIST IN (SELECT FCM_ATIVIDADECHK.NRCHECKLIST
            FROM FCM_ATIVIDADECHK
           WHERE FCM_ATIVIDADECHK.NRATIVIDADE = " . $param["lct"] . ")";
        }
        if ($param["tst"] != "null") {
            $params .= " AND FCM_LOCALCLI.NRTIPOLOCALCLI = " . $param["tst"];
        }

        $param1 = array(
            "startPeriod"    => $param['start'],
            "finishPeriod"   => $param['finish'],
            "CDOPERADOR"     => $this->Environment->getCdOperador(),
        );

        return $this->GerenciamentoChkFactory->listInspectionTask($param1, $params);
    }

    public function transferVistoria($param)
    {
        $this->connection->beginTransaction();

        try {
            $nrgerenciamentochk = implode(",", $param['idVistoria']);

            $this->GerenciamentoChkFactory->transferVistoria(array(
                "CDOPERADOR"           => $param['funcionarioDestino'],
                "CDOPERULTATU"         => $this->Environment->getCdOperador(),
                "NRORGULTATU"          => $this->Environment->getNrOrg()
            ), $nrgerenciamentochk);

            foreach ($param['idVistoria'] as $id) {
                $dadosHistorico = $this->GerenciamentoChkFactory->dadosVistoria($id);
                $dadosHistorico = $dadosHistorico[0];
                $dadosHistorico['funcionarioOrigem'] = $param['funcionarioOrigem'];
                $dadosHistorico['funcionarioDestino'] = $param['funcionarioDestino'];
                $dadosHistorico['operadorTransfer'] = $this->Environment->getCdOperador();
                $this->LogTransfergerchkService->insertLogTrasnfer($dadosHistorico);
            }

            $this->connection->commit();
        } catch (\Exception $e) {
            $this->connection->rollback();
            throw $e;
        }
    }

    public function innerJoinChecklist($params)
    {
        $gerenciamentoChks = $this->GerenciamentoChkFactory->gerenciamentoChkInnerJoinChecklist($params);
        return $gerenciamentoChks;
    }

    public function updateVistoria($params)
    {
        return $this->GerenciamentoChkFactory->updateVistoria($params);
    }
}
