import { Utilities } from '@/util/Utilities';
import {
    Form, LoadingService, Modal, ModalService, Select, SelectMultiple,
} from '@zeedhi/common';
import { Http, Metadata } from '@zeedhi/core';

export class Fm00002HierarquiaController {
    public modalHierarquia!: Modal;

    public async criarModal() {
        this.modalHierarquia = await ModalService.createFromJsonPost('', { jsonPath: 'fm_00002_000_gerenciar_locais/modal/fm_00008_001_modal_inserir_usuario' });
    }

    public destruirModal() {
        this.modalHierarquia.destroy();
    }

    public abrirModal() {
        this.modalHierarquia.show();
    }

    public fecharModal() {
        this.modalHierarquia.hide();
    }

    public salvarHierarquia() {
        const form = Metadata.getInstance<Form>('form-nova-hierarquia');

        if (Utilities.validateForm(form)) {
            Http.post('/inserirHierarquiaLocal', {
                NRLOCALCLIENTE: Metadata.getInstance<Select>('NRLOCALCLIENTE').value,
                CDOPERADOR: Metadata.getInstance<Select>('CDOPERADOR').value,
                CDOPERADORPAI: Metadata.getInstance<SelectMultiple>('CDOPERADORPAI').value,
            }).then(() => {
                // nada
            }).catch((error : any) => {
                Utilities.showErrorMessage(error);
            }).finally(() => {
                LoadingService.hide();
            });
        }
    }
}
